Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HiveServerManagementConsole.cs	(revision 4042)
@@ -44,4 +44,6 @@
   public delegate void closeForm(bool cf, bool error);
 
+  public delegate void updateListView(JobDataFetcher fetcher, ListView sender, int category);
+
   public partial class HiveServerManagementConsole : Form {
 
@@ -65,4 +67,10 @@
     private TreeNode hoverNode;
     private List<ListViewGroup> lvClientGroups;
+
+    private JobDataFetcher jdfFinished = null;
+    private JobDataFetcher jdfOffline = null;
+    private JobDataFetcher jdfCalculating = null;
+    
+      
     #endregion
 
@@ -85,22 +93,64 @@
       Init();
       AddClients();
-      AddJobs();
-      timerSyncronize.Start();
-    }
-
+      //AddJobs();
+      StartAutoUpdateTimers();
+      //timerSyncronize.Start();
+    }
+
+    private void StartAutoUpdateTimers() {
+      jdfCalculating.NewDataAvailable += new EventHandler(jdf_NewDataAvailable);
+      jdfOffline.NewDataAvailable += new EventHandler(jdf_NewDataAvailable);
+      jdfFinished.NewDataAvailable += new EventHandler(jdf_NewDataAvailable);
+      jdfFinished.Start();
+      jdfOffline.Start();
+      jdfCalculating.Start();
+    }
+
+    void jdf_NewDataAvailable(object sender, EventArgs e) {
+      JobDataFetcher fetcher = (JobDataFetcher) sender;
+      if (fetcher.PollStates.Contains(State.finished)) {
+        updateJobListView(fetcher, lv_finishedJobs, 0);
+      } else if(fetcher.PollStates.Contains(State.calculating)) {
+        updateJobListView(fetcher, lv_calculatingJobs, 1);
+      } else if (fetcher.PollStates.Contains(State.offline)) {
+        updateJobListView(fetcher, lv_offlineJobs, 2);
+      }
+    }
+
+    private void updateJobListView(JobDataFetcher fetcher, ListView listView, int category) {
+      if (listView.InvokeRequired) {
+        listView.Invoke(new updateListView(updateJobListView), new object[] { fetcher, listView, category });
+      } else {
+        listView.BeginUpdate();
+        listView.Items.Clear();
+        foreach (JobDto job in fetcher.CachedJobs) {
+          ListViewItem lvi = new ListViewItem(job.Id.ToString(), category);
+          lvi.Tag = job;
+          listView.Items.Add(lvi);
+        }
+        listView.EndUpdate();
+      }
+    }
+
+   
     private void Init() {
-      //adding context menu items for jobs
-      menuItemAbortJob.Click += (s, e) => {
-        IJobManager jobManager = ServiceLocator.GetJobManager();
-        if (lvJobControl.SelectedItems.Count == 1) {
-          jobManager.AbortJob(((JobDto)(lvJobControl.SelectedItems[0].Tag)).Id);
+
+      jdfFinished = new JobDataFetcher(new State[] {State.finished}, 50);
+      jdfCalculating = new JobDataFetcher(new State[] {State.calculating}, 50);
+      jdfOffline = new JobDataFetcher(new State[] {State.offline}, 50);
+
+      cmb_finishedJob_count.SelectedItem = "50";
+      cmb_offlineJob_count.SelectedItem = "50";
+      cmb_calculatingJob_count.SelectedItem = "50";
+      
+      calcToolStripAbortItem.Click += (s, e) => {
+        if(lv_calculatingJobs.SelectedItems.Count > 0) {
+          ServiceLocator.GetJobManager().AbortJob(((JobDto) lv_calculatingJobs.SelectedItems[0].Tag).Id);
         }
       };
 
-      //adding context menu items for jobs
-      menuItemGetSnapshot.Click += (s, e) => {
-        IJobManager jobManager = ServiceLocator.GetJobManager();
-        if (lvJobControl.SelectedItems.Count == 1) {
-          jobManager.RequestSnapshot(((JobDto)(lvJobControl.SelectedItems[0].Tag)).Id);
+      offlineItemAbortJob.Click += (s, e) => {
+        if (lv_offlineJobs.SelectedItems.Count > 0) {
+          ServiceLocator.GetJobManager().AbortJob(((JobDto)lv_offlineJobs.SelectedItems[0].Tag).Id);
         }
       };
@@ -256,72 +306,4 @@
 
 
-    /// <summary>
-    /// Adds Exceptionobs to ListView and TreeView
-    /// </summary>
-    private void AddJobs() {
-      try {
-        List<ListViewItem> jobObjects = new List<ListViewItem>();
-        IJobManager jobManager =
-          ServiceLocator.GetJobManager();
-        if (jobManager == null) {
-          Logger.Error("Jobmanager is null");
-          jobs = new ResponseList<JobDto>();
-        } else {
-          jobs = jobManager.GetAllJobs();
-        }
-
-
-        if (lvJobControl != null) lvJobControl.Items.Clear();
-
-        ListViewGroup lvJobCalculating = new ListViewGroup("calculating", HorizontalAlignment.Left);
-        ListViewGroup lvJobFinished = new ListViewGroup("finished", HorizontalAlignment.Left);
-        ListViewGroup lvJobPending = new ListViewGroup("pending", HorizontalAlignment.Left);
-
-        jobGroup = new List<ListViewGroup>();
-        jobGroup.Add(lvJobCalculating);
-        jobGroup.Add(lvJobFinished);
-        jobGroup.Add(lvJobPending);
-
-        if (jobs != null && jobs.List != null) {
-
-          foreach (JobDto job in jobs.List) {
-            if (job.State == State.calculating) {
-              ListViewItem lvi = new ListViewItem(job.Id.ToString(), 1, lvJobCalculating);
-              lvi.Tag = job;
-              jobObjects.Add(lvi);
-
-              lvi.ToolTipText = (job.Percentage * 100) + "% of job calculated";
-            } else if (job.State == State.finished) {
-              ListViewItem lvi = new ListViewItem(job.Id.ToString(), 0, lvJobFinished);
-              lvi.Tag = job;
-              jobObjects.Add(lvi);
-            } else if (job.State == State.offline || job.State == State.pending) {
-              ListViewItem lvi = new ListViewItem(job.Id.ToString(), 2, lvJobPending);
-              lvi.Tag = job;
-              jobObjects.Add(lvi);
-            }
-          } // Jobs
-          lvJobControl.BeginUpdate();
-          foreach (ListViewItem lvi in jobObjects) {
-            lvJobControl.Items.Add(lvi);
-          }
-          // actualization
-          lvJobControl.Groups.Add(lvJobCalculating);
-          lvJobControl.Groups.Add(lvJobFinished);
-          lvJobControl.Groups.Add(lvJobPending);
-          lvJobControl.EndUpdate();
-
-          if (currentJob != null) {
-            JobClicked();
-          }
-        }
-      }
-      catch (Exception ex) {
-        Logger.Error(ex);
-        closeFormEvent(true, true);
-        this.Close();
-      }
-    }
-
     private void AddClients() {
       lvClientGroups = new List<ListViewGroup>();
@@ -543,5 +525,5 @@
 
     private void RefreshJob(Changes change) {
-      if (change.ChangeType == Change.Update) {
+      /*if (change.ChangeType == Change.Update) {
         for (int i = 0; i < lvJobControl.Items.Count; i++) {
           if (lvJobControl.Items[i].Text == change.ID.ToString()) {
@@ -591,5 +573,5 @@
           }
         }
-      }
+      }                    */
     }
 
@@ -626,12 +608,14 @@
 
     private void OnLVJobControlClicked(object sender, EventArgs e) {
-      currentJob = (JobDto)lvJobControl.SelectedItems[0].Tag;
+      JobListView jlv = (JobListView) sender;
+      currentJob = (JobDto)jlv.SelectedItems[0].Tag;
       JobClicked();
     }
 
     private void lvJobControl_MouseMove(object sender, MouseEventArgs e) {
-      if ((lvJobControl.GetItemAt(e.X, e.Y) != null) &&
-        (lvJobControl.GetItemAt(e.X, e.Y).ToolTipText != null)) {
-        tt.SetToolTip(lvJobControl, lvJobControl.GetItemAt(e.X, e.Y).ToolTipText);
+      JobListView jlv = (JobListView) sender;
+      if ((jlv.GetItemAt(e.X, e.Y) != null) &&
+        (jlv.GetItemAt(e.X, e.Y).ToolTipText != null)) {
+        tt.SetToolTip(jlv, jlv.GetItemAt(e.X, e.Y).ToolTipText);
       }
     }
@@ -640,15 +624,16 @@
       // If the right mouse button was clicked and released,
       // display the shortcut menu assigned to the ListView. 
-      lvJobControl.ContextMenuStrip.Items.Clear();
-      ListViewHitTestInfo hitTestInfo = lvJobControl.HitTest(e.Location);
-      if (e.Button == MouseButtons.Right && hitTestInfo.Item != null && lvJobControl.SelectedItems.Count == 1) {
-        JobDto selectedJob = (JobDto)lvJobControl.SelectedItems[0].Tag;
+      JobListView jlv = (JobListView)sender;
+      jlv.ContextMenuStrip.Items.Clear();
+      ListViewHitTestInfo hitTestInfo = jlv.HitTest(e.Location);
+      if (e.Button == MouseButtons.Right && hitTestInfo.Item != null && jlv.SelectedItems.Count == 1) {
+        JobDto selectedJob = (JobDto)jlv.SelectedItems[0].Tag;
 
         if (selectedJob != null && selectedJob.State == State.calculating) {
-          lvJobControl.ContextMenuStrip.Items.Add(menuItemAbortJob);
-          lvJobControl.ContextMenuStrip.Items.Add(menuItemGetSnapshot);
-        }
-      }
-      lvJobControl.ContextMenuStrip.Show(new Point(e.X, e.Y));
+          jlv.ContextMenuStrip.Items.Add(offlineItemAbortJob);
+          jlv.ContextMenuStrip.Items.Add(menuItemGetSnapshot);
+        }
+      }
+      jlv.ContextMenuStrip.Show(new Point(e.X, e.Y));
     }
 
@@ -745,5 +730,5 @@
     private void largeIconsToolStripMenuItem_Click(object sender, EventArgs e) {
       lvClientControl.View = View.LargeIcon;
-      lvJobControl.View = View.LargeIcon;
+      //lvJobControl.View = View.LargeIcon;
       largeIconsToolStripMenuItem.CheckState = CheckState.Checked;
       smallIconsToolStripMenuItem.CheckState = CheckState.Unchecked;
@@ -753,5 +738,5 @@
     private void smallIconsToolStripMenuItem_Click(object sender, EventArgs e) {
       lvClientControl.View = View.SmallIcon;
-      lvJobControl.View = View.SmallIcon;
+      //lvJobControl.View = View.SmallIcon;
       largeIconsToolStripMenuItem.CheckState = CheckState.Unchecked;
       smallIconsToolStripMenuItem.CheckState = CheckState.Checked;
@@ -761,5 +746,5 @@
     private void listToolStripMenuItem_Click(object sender, EventArgs e) {
       lvClientControl.View = View.List;
-      lvJobControl.View = View.List;
+      //lvJobControl.View = View.List;
       largeIconsToolStripMenuItem.CheckState = CheckState.Unchecked;
       smallIconsToolStripMenuItem.CheckState = CheckState.Unchecked;
@@ -859,6 +844,51 @@
     #endregion
 
-
-
+    private void btn_prev_Click(object sender, EventArgs e) {
+      if (sender == btn_finishedJob_prev)
+        jdfFinished.Backward();
+      else if (sender == btn_calculatingJobs_prev)
+        jdfCalculating.Backward();
+      else if (sender == btn_offlinejob_prev) {
+        jdfOffline.Backward();
+      }
+    }
+
+    private void btn_next_Click(object sender, EventArgs e) {
+      if (sender == btn_finishedJob_next)
+        jdfFinished.Forward();
+      else if (sender == btn_calculatingJobs_next)
+        jdfCalculating.Forward();
+      else if (sender == btn_offlineJob_next) {
+        jdfOffline.Forward();
+      }
+    }
+
+    private void cmb_count_SelectedIndexChanged(object sender, EventArgs e) {
+      ComboBox box = (ComboBox) sender;
+      if (box.SelectedItem != null) {
+        int val;
+        if (Int32.TryParse(box.SelectedItem.ToString(), out val)) {
+          if (box == cmb_offlineJob_count) {
+            jdfOffline.NrOfEntriesOnPage = val;
+          }
+          else if (box == cmb_finishedJob_count) {
+            jdfFinished.NrOfEntriesOnPage = val;
+          }
+          else if (box == cmb_calculatingJob_count) {
+            jdfCalculating.NrOfEntriesOnPage = val;
+          }
+        }
+      }
+    }
+
+    private void lv_Jobs_SelectedIndexChanged(object sender, EventArgs e) {
+      ListView lv = (ListView) sender;
+      if(lv.SelectedItems.Count > 0) {
+        foreach (ListViewItem lvi in lv.SelectedItems) {
+          currentJob = (JobDto) lvi.Tag;
+          JobClicked();          
+        }
+      }
+    }
   }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobDataFetcher.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobDataFetcher.cs	(revision 4042)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobDataFetcher.cs	(revision 4042)
@@ -0,0 +1,88 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Timers;
+using HeuristicLab.Hive.Contracts;
+using System.Collections;
+using System.Threading;
+
+namespace HeuristicLab.Hive.Server.ServerConsole {
+  public class JobDataFetcher {
+    public List<State> PollStates { get; set; }    
+
+    public event EventHandler NewDataAvailable;
+
+    private System.Timers.Timer timer;
+
+    public List<JobDto> CachedJobs { get; set; }
+
+    public double Interval {
+      get { return timer.Interval; }
+      set { timer.Interval = value; }
+    }
+
+    private int _nrOfEntriesOnPage;
+    public int NrOfEntriesOnPage {
+      get {
+        return _nrOfEntriesOnPage;
+      }
+      set {
+        Console.WriteLine("Setting for " + PollStates + " changed to: " + value);        
+        _nrOfEntriesOnPage = value;        
+        Thread t = new Thread(new ThreadStart(DoUpdateRun));
+        t.Start();        
+      }
+    }    
+    public int CurrentPage { get; set; }
+
+    public JobDataFetcher(IEnumerable<State> states, int nrOfEntries) {
+      PollStates = new List<State>();
+      CachedJobs = new List<JobDto>();
+      NrOfEntriesOnPage = nrOfEntries;
+      CurrentPage = 0;
+      PollStates.AddRange(states);
+      timer = new System.Timers.Timer();
+      timer.Interval = 5000;
+      timer.Elapsed += new ElapsedEventHandler(Timer_Elapsed);      
+    }
+
+    public void Start() {
+      timer.Start();
+    }
+
+    public void Forward() {
+      CurrentPage++;
+      DoUpdateRun();
+    }
+    public void Backward() {
+      if (CurrentPage != 0)
+        CurrentPage--;
+      DoUpdateRun();
+    } 
+
+    private void Timer_Elapsed(object sender, ElapsedEventArgs e) {
+      DoUpdateRun();
+    }
+
+    private void DoUpdateRun() {      
+      foreach (State stat in PollStates) {
+        ResponseList<JobDto> resList = ServiceLocator.GetJobManager().GetAllJobsWithFilter(stat, CurrentPage * NrOfEntriesOnPage,
+                                                            NrOfEntriesOnPage);
+        if (resList.Success) {
+          if (resList.List.Count == 0) {
+            if (CurrentPage > 0) {
+              CurrentPage--;
+            }
+          } else {
+            CachedJobs = new List<JobDto>();
+            CachedJobs.AddRange(resList.List);
+          }
+        }
+      }
+      if (NewDataAvailable != null)
+        NewDataAvailable(this, new EventArgs());
+    }
+  }
+}
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListView.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListView.cs	(revision 4042)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListView.cs	(revision 4042)
@@ -0,0 +1,138 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Contracts.Interfaces;
+
+namespace HeuristicLab.Hive.Server.ServerConsole {
+  public class JobListView : ListView {
+    private ContextMenuStrip contextMenuJob;
+    private System.ComponentModel.IContainer components;
+    private ToolStripMenuItem menuItemAbortJob;
+    private ToolStripMenuItem menuItemGetSnapshot;
+    private ImageList ilLargeImgJob;
+    private ImageList ilSmallImgJob;
+
+    public int NrOfEntriesOnPage { 
+      get {
+        return jdf.NrOfEntriesOnPage;
+      } 
+      set {
+        jdf.NrOfEntriesOnPage = value;
+      }
+    }
+
+
+    private JobDataFetcher jdf;
+
+    public JobListView(IEnumerable<State> states, int nrOfEntries)
+      : base() {
+      InitializeComponent();
+      InitializeCustomControls();
+      jdf = new JobDataFetcher(states, nrOfEntries);
+      jdf.NewDataAvailable += new EventHandler(JdfNewDataAvailable);
+      jdf.Start();
+    }
+
+    private void JdfNewDataAvailable(object sender, EventArgs e) {
+      JobDataFetcher datafetcher = (JobDataFetcher) sender;
+      this.BeginUpdate();
+      if (datafetcher.PollStates.Contains(State.finished)) {
+        this.Items.Clear();
+        ListViewItem lviDummy = new ListViewItem("blahr", 0);
+        this.Items.Add(lviDummy);
+        foreach (JobDto job in datafetcher.CachedJobs) {
+          ListViewItem lvi = new ListViewItem(job.Id.ToString(), 0);
+          lvi.Tag = job;
+          this.Items.Add(lvi);
+        }
+      }
+      this.EndUpdate();
+    }
+
+    public void Forward() {
+      jdf.Forward();
+    }
+
+    public void Backward() {
+      jdf.Backward();
+    }
+
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(JobListView));
+      this.contextMenuJob = new System.Windows.Forms.ContextMenuStrip(this.components);
+      this.menuItemAbortJob = new System.Windows.Forms.ToolStripMenuItem();
+      this.menuItemGetSnapshot = new System.Windows.Forms.ToolStripMenuItem();
+      this.ilLargeImgJob = new System.Windows.Forms.ImageList(this.components);
+      this.ilSmallImgJob = new System.Windows.Forms.ImageList(this.components);
+      this.contextMenuJob.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // contextMenuJob
+      // 
+      this.contextMenuJob.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.menuItemAbortJob,
+            this.menuItemGetSnapshot});
+      this.contextMenuJob.Name = "contextMenuJob";
+      this.contextMenuJob.Size = new System.Drawing.Size(145, 48);
+      // 
+      // menuItemAbortJob
+      // 
+      this.menuItemAbortJob.Name = "menuItemAbortJob";
+      this.menuItemAbortJob.Size = new System.Drawing.Size(144, 22);
+      this.menuItemAbortJob.Text = "Abort";
+      // 
+      // menuItemGetSnapshot
+      // 
+      this.menuItemGetSnapshot.Name = "menuItemGetSnapshot";
+      this.menuItemGetSnapshot.Size = new System.Drawing.Size(144, 22);
+      this.menuItemGetSnapshot.Text = "Get Snapshot";
+      // 
+      // ilLargeImgJob
+      // 
+      this.ilLargeImgJob.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilLargeImgJob.ImageStream")));
+      this.ilLargeImgJob.TransparentColor = System.Drawing.Color.Transparent;
+      this.ilLargeImgJob.Images.SetKeyName(0, "ok.png");
+      this.ilLargeImgJob.Images.SetKeyName(1, "Forward.png");
+      this.ilLargeImgJob.Images.SetKeyName(2, "pause.png");
+      // 
+      // ilSmallImgJob
+      // 
+      this.ilSmallImgJob.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilSmallImgJob.ImageStream")));
+      this.ilSmallImgJob.TransparentColor = System.Drawing.Color.Transparent;
+      this.ilSmallImgJob.Images.SetKeyName(0, "ok.png");
+      this.ilSmallImgJob.Images.SetKeyName(1, "Forward.png");
+      this.ilSmallImgJob.Images.SetKeyName(2, "pause.png");
+      // 
+      // JobListView
+      // 
+      this.LargeImageList = this.ilLargeImgJob;
+      this.SmallImageList = this.ilSmallImgJob;
+      this.contextMenuJob.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    private void InitializeCustomControls() {
+      menuItemAbortJob.Click += (s, e) => {
+                                  IJobManager jobManager = ServiceLocator.GetJobManager();
+                                  if (this.SelectedItems.Count == 1) {
+                                    jobManager.AbortJob(((JobDto) (this.SelectedItems[0].Tag)).Id);
+                                  }
+                                };
+
+      //adding context menu items for jobs
+      menuItemGetSnapshot.Click += (s, e) => {
+                                     IJobManager jobManager = ServiceLocator.GetJobManager();
+                                     if (this.SelectedItems.Count == 1) {
+                                       jobManager.RequestSnapshot(((JobDto) (this.SelectedItems[0].Tag)).Id);
+                                     }
+                                   };
+      
+      
+    }
+  }
+}
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListViewControl.Designer.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListViewControl.Designer.cs	(revision 4042)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListViewControl.Designer.cs	(revision 4042)
@@ -0,0 +1,118 @@
+﻿namespace HeuristicLab.Hive.Server.ServerConsole {
+  partial class JobListViewControl {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.splitContainer1 = new System.Windows.Forms.SplitContainer();
+      this.comboBox1 = new System.Windows.Forms.ComboBox();
+      this.btn_finishedJob_next = new System.Windows.Forms.Button();
+      this.btn_finishedJob_prev = new System.Windows.Forms.Button();
+      this.listView1 = new JobListView(null, 5);
+      this.splitContainer1.Panel1.SuspendLayout();
+      this.splitContainer1.Panel2.SuspendLayout();
+      this.splitContainer1.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // splitContainer1
+      // 
+      this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer1.Location = new System.Drawing.Point(0, 0);
+      this.splitContainer1.Name = "splitContainer1";
+      this.splitContainer1.Orientation = System.Windows.Forms.Orientation.Horizontal;
+      // 
+      // splitContainer1.Panel1
+      // 
+      this.splitContainer1.Panel1.Controls.Add(this.comboBox1);
+      this.splitContainer1.Panel1.Controls.Add(this.btn_finishedJob_next);
+      this.splitContainer1.Panel1.Controls.Add(this.btn_finishedJob_prev);
+      // 
+      // splitContainer1.Panel2
+      // 
+      this.splitContainer1.Panel2.Controls.Add(this.listView1);
+      this.splitContainer1.Size = new System.Drawing.Size(586, 479);
+      this.splitContainer1.SplitterDistance = 31;
+      this.splitContainer1.TabIndex = 0;
+      // 
+      // comboBox1
+      // 
+      this.comboBox1.FormattingEnabled = true;
+      this.comboBox1.Items.AddRange(new object[] {
+            "25",
+            "50",
+            "75",
+            "100"});
+      this.comboBox1.Location = new System.Drawing.Point(165, 3);
+      this.comboBox1.Name = "comboBox1";
+      this.comboBox1.Size = new System.Drawing.Size(48, 21);
+      this.comboBox1.TabIndex = 5;
+      // 
+      // btn_finishedJob_next
+      // 
+      this.btn_finishedJob_next.Location = new System.Drawing.Point(84, 3);
+      this.btn_finishedJob_next.Name = "btn_finishedJob_next";
+      this.btn_finishedJob_next.Size = new System.Drawing.Size(75, 23);
+      this.btn_finishedJob_next.TabIndex = 4;
+      this.btn_finishedJob_next.Text = "-->";
+      this.btn_finishedJob_next.UseVisualStyleBackColor = true;
+      // 
+      // btn_finishedJob_prev
+      // 
+      this.btn_finishedJob_prev.Location = new System.Drawing.Point(3, 3);
+      this.btn_finishedJob_prev.Name = "btn_finishedJob_prev";
+      this.btn_finishedJob_prev.Size = new System.Drawing.Size(75, 23);
+      this.btn_finishedJob_prev.TabIndex = 3;
+      this.btn_finishedJob_prev.Text = "<--";
+      this.btn_finishedJob_prev.UseVisualStyleBackColor = true;
+      // 
+      // listView1
+      // 
+      this.listView1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.listView1.Location = new System.Drawing.Point(0, 0);
+      this.listView1.Name = "listView1";
+      this.listView1.Size = new System.Drawing.Size(586, 444);
+      this.listView1.TabIndex = 0;
+      this.listView1.UseCompatibleStateImageBehavior = false;
+      // 
+      // JobListViewControl
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.splitContainer1);
+      this.Name = "JobListViewControl";
+      this.Size = new System.Drawing.Size(586, 479);
+      this.splitContainer1.Panel1.ResumeLayout(false);
+      this.splitContainer1.Panel2.ResumeLayout(false);
+      this.splitContainer1.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.SplitContainer splitContainer1;
+    private System.Windows.Forms.ComboBox comboBox1;
+    private System.Windows.Forms.Button btn_finishedJob_next;
+    private System.Windows.Forms.Button btn_finishedJob_prev;
+    private System.Windows.Forms.ListView listView1;
+  }
+}
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListViewControl.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListViewControl.cs	(revision 4042)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/JobListViewControl.cs	(revision 4042)
@@ -0,0 +1,16 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Hive.Server.ServerConsole {
+  public partial class JobListViewControl : UserControl {
+    public JobListViewControl() {
+      InitializeComponent();
+    }
+  }
+}
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/ServiceLocator.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/ServiceLocator.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/ServiceLocator.cs	(revision 4042)
@@ -34,7 +34,14 @@
                          
         serverConsoleFacade = factory.CreateChannel();
+        ((ICommunicationObject)serverConsoleFacade).Faulted += ServiceLocator_Faulted;
       }
       
       return serverConsoleFacade;
+    }
+
+    static void ServiceLocator_Faulted(object sender, EventArgs e) {
+      ((ICommunicationObject)serverConsoleFacade).Abort();
+      ((ICommunicationObject)serverConsoleFacade).Faulted -= ServiceLocator_Faulted;
+      serverConsoleFacade = null;
     }
 
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 4042)
@@ -725,10 +725,10 @@
             CachedHivePluginInfoDto currCachedPlugin = new CachedHivePluginInfoDto {
               Name = currPlugin.Name,
-              Version = currPlugin.Version.ToString(),
+              Version = currPlugin.Version,
               BuildDate = currPlugin.BuildDate
             };
 
             foreach (string fileName in from file in currPlugin.Files select file.Name) {
-              currCachedPlugin.PluginFiles.Add(File.ReadAllBytes(fileName));
+              currCachedPlugin.PluginFiles.Add(new HivePluginFile(File.ReadAllBytes(fileName), fileName));
             }
             response.Plugins.Add(currCachedPlugin);
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/ClientFacade.cs	(revision 4042)
@@ -100,4 +100,5 @@
     #region IClientFacade Members
 
+    [SpringTransaction(UserTransaction = true)]
     public Stream SendStreamedJob(Guid clientId) {
       MultiStream stream =
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/DefaultScheduler.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/DefaultScheduler.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/DefaultScheduler.cs	(revision 4042)
@@ -8,4 +8,6 @@
 using System.Threading;
 using HeuristicLab.DataAccess.Interfaces;
+using System.Transactions;
+using HeuristicLab.Hive.Contracts;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -32,20 +34,21 @@
       /// Critical section ///
       jobLock.WaitOne();
-
-      ClientDto client = DaoLocator.ClientDao.FindById(clientId);
-      LinkedList<JobDto> allOfflineJobsForClient =
-        new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobsForClient(State.offline, client.NrOfFreeCores,
-                                                                          client.FreeMemory, client.Id));
-
       JobDto jobToCalculate = null;
-      if (allOfflineJobsForClient != null && allOfflineJobsForClient.Count > 0) {
-        jobToCalculate = allOfflineJobsForClient.First.Value;
-        jobToCalculate.State = State.calculating;
-        jobToCalculate.Client = client;
-        jobToCalculate.Client.State = State.calculating;
-        jobToCalculate.DateCalculated = DateTime.Now;
-        DaoLocator.JobDao.AssignClientToJob(client.Id, jobToCalculate.Id);
-        DaoLocator.JobDao.Update(jobToCalculate);
-        DaoLocator.ClientDao.Update(jobToCalculate.Client);
+      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
+        ClientDto client = DaoLocator.ClientDao.FindById(clientId);
+        LinkedList<JobDto> allOfflineJobsForClient =
+          new LinkedList<JobDto>(DaoLocator.JobDao.FindFittingJobsForClient(State.offline, client.NrOfFreeCores,
+                                                                            client.FreeMemory, client.Id));        
+        if (allOfflineJobsForClient != null && allOfflineJobsForClient.Count > 0) {
+          jobToCalculate = allOfflineJobsForClient.First.Value;
+          jobToCalculate.State = State.calculating;
+          jobToCalculate.Client = client;
+          jobToCalculate.Client.State = State.calculating;
+          jobToCalculate.DateCalculated = DateTime.Now;
+          DaoLocator.JobDao.AssignClientToJob(client.Id, jobToCalculate.Id);
+          DaoLocator.JobDao.Update(jobToCalculate);
+          DaoLocator.ClientDao.Update(jobToCalculate.Client);
+        }
+        scope.Complete();
       }
       jobLock.ReleaseMutex();
